<?php
require_once('facebook_app.php');
require_once('config.php');
require_once('vb_api_client.php');

if(!(!empty($_SERVER['HTTP_X_REQUESTED_WITH']) && strstr($_SERVER['HTTP_X_REQUESTED_WITH'], 'XMLHttpRequest'))) {
    header('HTTP/1.1 404 Not Found');
    header('Connection: close');
    exit;
}

if( empty($_POST['username']) || empty($_POST['email']) || empty($_POST['password'])) {
    header('HTTP/1.1 404 Not Found');
    header('Connection: close');
    exit;
}

$app = FacebookApp::instance();
$facebook = $app->getFacebookInterface();
$me = $facebook->api('/me');

$usecoppa = $_POST['usecoppa'];
$facebookBirthdate = isset($_POST['facebookBirthdate'])? $_POST['facebookBirthdate'] : '';

$day = isset($_POST['day'])? $_POST['day'] : '';
$month = isset($_POST['month'])? $_POST['month'] : '';
$year = isset($_POST['year'])? $_POST['year'] : '';

$post['signed_request'] = $_POST['signed_request'];
$post['agree'] = 1;
$post['username'] = $_POST['username'];
$post['email'] = $_POST['email'];
$post['emailconfirm'] = $_POST['email'];
$post['password'] = $_POST['password'];
$post['passwordconfirm'] = $_POST['password'];
$post['fbname'] = $me['name'];
$post['fbuserid'] = $me['id'];
if(!empty($day)){
    $post['month'] = $month;
    $post['day'] = $day;
    $post['year'] = $year;
}
$profileFieldsArray = array(); 

foreach($_POST as $key => $value) {
    for($i = 1 ; $i <= count($_POST); $i++){
        if($key == 'field' . $i){
            if(substr_count($value, ',') > 0){ $value_aux = explode(",", $value); $profileFieldsArray[$key] = $value_aux; }
            else
                $profileFieldsArray[$key] = $value;
            break;
        }
    }
}


$link_lostpassword = '<a href="' . vB_SITE_ROOT . 'login.php?do=lostpw" target="_blank">here</a>';
$error_messages = array(
    'alreadyregistered' => array(true, false, 'This facebook account is already registered.'),
    'registeremail' => array(true, false, 'Registration successful, please check your email to activate.'),
    'moderateuser' => array(true, false, 'Registration successful, please allow time for a moderator to approve your account.'),
    'noregister' => array(false, true, 'This board is not currently accepting new members.'),
    'registration_complete' => array(true, false, 'Registration successful!'),
    'emailtaken' => array(false, true, 'That email is already taken!'),
    'bademail' => array(false, true, 'Please check to ensure you have entered a valid email address.'),
    'usernametaken' => array(false, true, 'That username is already taken or does not meet the administrator\'s standards. If you are ' . $_POST['username'] . ' and you have forgotten your password, click ' . $link_lostpassword),
    'regexincorrect' => array(false, true, 'This field does not meet the administrator\'s standards. Please contact the administrator for more information.'),
    'usernametoolong' => array(false, true, 'That username is too long!'),
    'facebook_account_already_registered' => array(true, false, 'This facebook account is already registered.'),
    'select_valid_dob' => array(false,true,'The birthday passed to this method is invalid.')
);   

if($usecoppa){
    $json = json_decode(VBApiClient::instance()->call_cached("register_checkdate", array(), array('month' => $month, 'year' => $year, 'day' => $day)), true);
    echo json_encode($json);
    if( array_key_exists('errormessage', $json['response']) && array_key_exists($json['response']['errormessage'][0], $error_messages)){
        echo json_encode(array("redirect" => false, "error" => true, "message" => $error_messages[$json['response']['errormessage'][0]]));
        exit;
    }
}


if(count($profileFieldsArray) > 0)
    $post['userfield'] = $profileFieldsArray;
$results = json_decode(VBApiClient::instance()->call_cached("register_addmember", array(), $post), true);
error_log(json_encode($results));

if(isset($results['response']['errorlist'])) {
    $error_message = array();
    foreach($results['response']['errorlist'] as $error) {
        $error_return = @$error_messages[$error[0]];
        if(isset($error_return)) {
            $error_message[] = $error_return;
        } else {
	    if(array_key_exists('1',$error))
                $error_message[] = array(false, true, $error[1]);
  	    else
		$error_message[] = array(false, true, $error[0]);
        }
    }
    $final_redirect = false;
    $final_error = true;
    $final_message = '';
    foreach($error_message as $error_return) {
        $final_redirect = $final_redirect || $error_return[0];
        $final_error = $final_error && $error_return[1];
        $final_message .= $error_return[2] . '<br/>';
    } 
    echo json_encode(array("redirect" => $final_redirect, "error" => $final_error, "message" => $final_message));
} else if(isset($results['response']['errormessage'])) {
    $errormessage = $results['response']['errormessage'][0];
    $error_return = $error_messages[$errormessage];
    if(isset($error_return)) {
        echo json_encode(array("redirect" => $error_return[0], "error" => $error_return[1], "message" => $error_return[2]));
    } else {
        echo json_encode(array("redirect" => false, "error" => true, "message" => 'Unable to complete registration at this time, please try again later.'));
    }
} else {
     echo json_encode(array("redirect" => false, "error" => true, "message" => 'Unable to complete registration at this time, please try again later.'));
}
exit;
?>
